
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

    <title>A persistent message &#8212; Varnish version 6.0.11 documentation</title>
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/classic.css" />
    
    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="Raking in the dough on Free and Open Source Software" href="dough.html" />
    <link rel="prev" title="SSL revisited" href="ssl_again.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="dough.html" title="Raking in the dough on Free and Open Source Software"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="ssl_again.html" title="SSL revisited"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" accesskey="U">Poul-Hennings random outbursts</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">A persistent message</a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <section id="a-persistent-message">
<span id="phk-pesistent"></span><h1>A persistent message<a class="headerlink" href="#a-persistent-message" title="Permalink to this headline">¶</a></h1>
<p>This message is about -spersistent and why you should not use it,
even though it is still present in Varnish 4.x. Starting with Varnish
6 it is only present when explicitly enabled at compile time.</p>
<section id="tl-dr">
<h2>TL;DR:<a class="headerlink" href="#tl-dr" title="Permalink to this headline">¶</a></h2>
<p>Under narrow and ill defined circumstances, -spersistent works well,
but in general it is more trouble than it is worth for you to run
it, and we don’t presently have the development resources to fix that.</p>
<p>If you think you have these circumstances, you need to specify</p>
<blockquote>
<div><p>-sdeprecated_persistent</p>
</div></blockquote>
<p>in order to use it.</p>
</section>
<section id="the-long-story">
<h2>The long story<a class="headerlink" href="#the-long-story" title="Permalink to this headline">¶</a></h2>
<p>When we added -spersistent, to Varnish, it was in response to, and
sponsored by a specific set of customers who really wanted this.</p>
<p>A persistent storage module is an entirely different kettle of vax
than a non-persistent module, because of all the ugly consistency
issues it raises.</p>
<p>Let me give you an example.</p>
<p>Imagine a cluster of some Varnish servers on which bans are used.</p>
<p>Without persistent storage, if one of them goes down and comes back
up, all the old cached objects are gone, and so are, by definition
all the banned objects.</p>
<p>With persistent storage, we not only have to store the still live
bans with the cached objects, and keep the two painfully in sync,
so the bans gets revived with the objects, we also have to worry
about missing bans during the downtime, since those might ban objects
we will recover on startup.</p>
<p>Ouch:  Straight into database/filesystem consistency territory.</p>
<p>But we knew that, and I thought I had a good strategy to deal with
this.</p>
<p>And in a sense I did.</p>
<p>Varnish has the advantage over databases and filesystems that we
can actually loose objects without it being a catastrophe.  It would
be better if we didn’t, but we can simply ditch stuff which doesn’t
look consistent and we’ll be safe.</p>
<p>The strategy was to do a “Log Structured Filesystem”, a once promising
concept which soon proved very troublesome to implement well.</p>
<p>Interestingly, today the ARM chip in your SSD most likely implements
a LFS for wear-levelling, but with a vastly reduced feature set:
All “files” are one sector long, filenames are integers and there
are no subdirectories or rename operations.  On the other hand,
there is extra book-keeping about the state of the flash array.</p>
<p>A LFS consists of two major components:  The bit that reads and
writes, which is pretty trivial, and the bit which makes space
available which isn’t.</p>
<p>Initially we didn’t even do the second part, because in varnish
objects expire, and provided they do so fast enough, the space will
magically make itself available.  This worked well enough for our
initial users, and they only used bans sporadically so that was
cool too.</p>
<p>In other words, a classic 20% effort, 80% benefit.</p>
<p>Unfortunately we have not been able to find time and money for the
other 80% effort which gives the last 20% benefit, and therefor
-spersistent has ended up in limbo.</p>
<p>Today we decided to officially deprecate -spersistent, and start
warning people against using it, but we will leave it in the source
code for now, in order to keep the interfaces necessary for a
persistent storage working, in the hope that we will get to use
them again later.</p>
<p>So you can still use persistent storage, if you really want to,
and if you know what you’re doing, by using:</p>
<blockquote>
<div><p>-sdeprecated_persistent</p>
</div></blockquote>
<p>You’ve been warned.</p>
<p>Poul-Henning, 2014-05-26</p>
</section>
</section>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">A persistent message</a><ul>
<li><a class="reference internal" href="#tl-dr">TL;DR:</a></li>
<li><a class="reference internal" href="#the-long-story">The long story</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="ssl_again.html"
                        title="previous chapter">SSL revisited</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="dough.html"
                        title="next chapter">Raking in the dough on Free and Open Source Software</a></p>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="../_sources/phk/persistent.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="dough.html" title="Raking in the dough on Free and Open Source Software"
             >next</a> |</li>
        <li class="right" >
          <a href="ssl_again.html" title="SSL revisited"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" >Poul-Hennings random outbursts</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">A persistent message</a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2010-2014, Varnish Software AS.
      Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 4.3.2.
    </div>
  </body>
</html>